// EditorDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Editor.h"
#include "EditorDlg.h"
#include <direct.h>


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define LEVELVIEW_X 10
#define LEVELVIEW_Y 10

#include <math.h>
#include "InputDlg.h"

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CEditorDlg dialog

CEditorDlg::CEditorDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CEditorDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CEditorDlg)
	m_strRadius = _T("");
	m_strWeight = _T("");
	m_InfoLine = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CEditorDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CEditorDlg)
	DDX_Control(pDX, IDC_OBJECTLIST, m_ObjectList);
	DDX_Control(pDX, IDC_MAINFRAME, m_LevelView);
	DDX_Text(pDX, IDC_RADIUS, m_strRadius);
	DDX_Text(pDX, IDC_WEIGHT, m_strWeight);
	DDX_Text(pDX, IDC_INFOLINE, m_InfoLine);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CEditorDlg, CDialog)
	//{{AFX_MSG_MAP(CEditorDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_NEW, OnNew)
	ON_BN_CLICKED(IDC_SAVE, OnSave)
	ON_BN_CLICKED(IDC_SAVEAS, OnSaveas)
	ON_NOTIFY(UDN_DELTAPOS, IDC_SPINRADIUS, OnDeltaposSpinradius)
	ON_BN_CLICKED(IDC_EDITMODE, OnEditmode)
	ON_BN_CLICKED(IDC_PAINTMODE, OnPaintmode)
	ON_BN_CLICKED(IDC_PLACEMODE, OnPlacemode)
	ON_WM_LBUTTONDOWN()
	ON_BN_CLICKED(IDC_LOAD, OnLoad)
	ON_BN_CLICKED(IDC_IMPORTTERRAIN, OnImportterrain)
	ON_WM_VSCROLL()
	ON_WM_MOUSEMOVE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CEditorDlg message handlers

BOOL CEditorDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	m_LevelView.SetWindowPos (NULL, LEVELVIEW_X, LEVELVIEW_Y, 256, 256*3, 0);
    OnNew ();

    m_strRadius = "20";
    m_strWeight = "128";
    m_BrushRadius = 50;
    m_BrushWeight = 10;
    m_Filename = "";
    m_ScrollPosition = 0;

    OnPaintmode ();
    UpdateData (FALSE);

    // Load in object list
    FILE *file = fopen ("objects.txt", "r");
    if (!file)
    {
        MessageBox ("failed to open objects.txt");
        return TRUE;
    }

    while (!feof (file))
    {
        char name[200];
        fscanf (file, "%s\n", name);

        m_ObjectList.AddString (name);
    }

    fclose (file);

    m_ObjBrush = CreateSolidBrush (RGB(255, 0, 0));

    GetModuleFileName( GetModuleHandle (NULL), m_AppPath, MAX_PATH-1);
    
    // strip off exe name to leave path
	for (int i=strlen(m_AppPath)-1; i>0; i--)
	{
		if (m_AppPath[i]=='\\')
		{
			m_AppPath[i]=0;
			break;
		}
	}

	_chdir (m_AppPath);
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CEditorDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CEditorDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
        PaintLevel ();
        
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CEditorDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CEditorDlg::OnNew() 
{
    m_LevelInfo.Initialize (3);  
    m_ScrollPosition = 0;
    InvalidateRect (NULL, false);
}

void CEditorDlg::OnLoad() 
{
    char path[200];
    sprintf (path, "%s\\*.LVL", m_AppPath);
    CFileDialog fileDialog  (true, "lvl", path, OFN_HIDEREADONLY | OFN_FILEMUSTEXIST, "Level files (*.LVL)\0*.LVL\0", this);	

    int ret = fileDialog.DoModal ();
    if (ret != IDCANCEL)
    {
        CString filename = fileDialog.GetPathName ();

        if (!m_LevelInfo.InitializeFromFile (filename.GetBuffer (50)))
        {
            MessageBox ("failed to load file");
            return;
        }

        m_Filename = filename;
    }
}

void CEditorDlg::OnSave() 
{
    if (m_Filename == "")
    {
        OnSaveas ();
        if (m_Filename == "")
            return;
    }

    if (!m_LevelInfo.WriteToFile (m_Filename.GetBuffer(20)))
    {
        MessageBox ("failed to save file");
        return;
    }
}

void CEditorDlg::OnSaveas() 
{
    char path[200];
    sprintf (path, "%s\\*.LVL", m_AppPath);
    CFileDialog fileDialog  (false, "lvl", path, OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT, "Level files (*.LVL)\0*.LVL\0", this);	

    int ret = fileDialog.DoModal ();
    if (ret != IDCANCEL)
    {
        m_Filename = fileDialog.GetPathName ();
    }
    else
        m_Filename = "";
}

void CEditorDlg::OnDeltaposSpinradius(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_UPDOWN* pNMUpDown = (NM_UPDOWN*)pNMHDR;
	// TODO: Add your control notification handler code here
	
	*pResult = 0;
}

bool   CEditorDlg::PaintLevel ()
{
    CDC *dc = m_LevelView.GetDC ();

    if (!m_LevelInfo.segments)
        return false;

    for (int i = 0; i < 3; i++)
    {
        for (int y = LEVEL_SEGMENT_SIZE; y > 0; y--)
        {
            for (int x = 0; x < LEVEL_SEGMENT_SIZE; x++)
            {
                // draw from the bottom up
                int p = i;

                if (i == 0) p = 2;
                if (i == 2) p = 0;

                POINT pt = {x,y+(LEVEL_SEGMENT_SIZE*p)};
                BYTE value = m_LevelInfo.segments[i+m_ScrollPosition].segmentData[x][y];
                dc->SetPixel (pt, RGB(value, value, value));
            }
        }

        FileLevelObject *obj = (FileLevelObject*)m_LevelInfo.segments[i+m_ScrollPosition].ObjectList.Rewind ();
        while (obj)
        {
            // draw from the bottom up
            int p = i;

            if (i == 0) p = 2;
            if (i == 2) p = 0;
            
            RECT rect;
            rect.left = obj->x - 4;
            rect.right = obj->x + 4;
            rect.top = (obj->y+(LEVEL_SEGMENT_SIZE*p))-4;
            rect.bottom = (obj->y+(LEVEL_SEGMENT_SIZE*p))+4;

            dc->SelectObject (m_ObjBrush);
            dc->Rectangle (&rect);

            obj = (FileLevelObject*)m_LevelInfo.segments[i+m_ScrollPosition].ObjectList.Next ();
        }
    }
    

    return true;
}

bool  CEditorDlg::MouseClickedOnMap (int x, int y)
{
    int segment = 0;
    int segx = x, segy;  

    //
    // Work out which segment we are on
    if (y < LEVEL_SEGMENT_SIZE) 
    {
        segment = 2 + m_ScrollPosition;
        segy = y;
    }
    else
    if (y < LEVEL_SEGMENT_SIZE*2) 
    {
        segment = 1 + m_ScrollPosition;
        segy = y-LEVEL_SEGMENT_SIZE;
    }
    else
    if (y < LEVEL_SEGMENT_SIZE*3) 
    {
        segment = 0 + m_ScrollPosition;
        segy = y-LEVEL_SEGMENT_SIZE*2;
    }

    /*if (m_LevelInfo.segments)
    {
        m_LevelInfo.segments[segment].segmentData[segx][segy] = m_BrushWeight;
    }*/
        
    //
    // Are we going to overlap onto a joining segment?
    bool bOverlapping = false;
    
    if (segy-m_BrushRadius <= 0 || segy+m_BrushRadius >= LEVEL_SEGMENT_SIZE)
        bOverlapping = true;

    //
    // If there is no overlap simply draw the circle at the given position
    /*if (!bOverlapping)
    {
        CDC *dc = m_LevelView.GetDC ();

       POINT pos;

        int _x = 0;
        int _y = m_BrushRadius;
        int d = 1 - m_BrushRadius;
        int deltaE = 3;
        int deltaSE = -2 * m_BrushRadius + 5;

        pos.x = _x+x; pos.y = _y+y;
        dc->SetPixel (pos, RGB(255,255,255));

        while ( _y > _x)
        {
            if (d < 0)
            {
                d+= deltaE;
                deltaSE += 2;
            }
            else
            {
                d+=deltaSE;
                deltaE+=2;
                _y--;
            }

            _x++;

            // Plot the pixels
            int pehx, pehy;
            int thiscolor;
            int thisradius;
            int linex;
            
            pehx = _x; pehy = _y;
            thisradius = m_BrushRadius - (m_BrushRadius-pehx);
            for (linex = -thisradius; linex < thisradius; linex++)
            {
                thiscolor = (int)((1.0f - (sqrt ((linex*linex)+(pehy*pehy)) / (float)m_BrushRadius)) * 255.0f);

                int newValue = m_LevelInfo.SetValueAdditive (segment, segx+linex, segy+pehy, thiscolor);
                if (newValue != -1)
                {
                    pos.x = linex+x; pos.y = y+pehy;
                    dc->SetPixel (pos, RGB(newValue,newValue,newValue));
                }
            }

            pehx = _y; pehy = _x;
            thisradius = m_BrushRadius - (m_BrushRadius-pehx);
            for (linex = -thisradius; linex < thisradius; linex++)
            {
                thiscolor = (int)((1.0f - (sqrt ((linex*linex)+(pehy*pehy)) / (float)m_BrushRadius)) * 255.0f);
                int newValue = m_LevelInfo.SetValueAdditive (segment, segx+linex, segy+pehy, thiscolor);
                if (newValue != -1)
                {
                    pos.x = linex+x; pos.y = y+pehy;
                    dc->SetPixel (pos, RGB(newValue,newValue,newValue));
                }
            }

            pehx = _y; pehy = -_x;
            thisradius = m_BrushRadius - (m_BrushRadius-pehx);
            for (linex = -thisradius; linex < thisradius; linex++)
            {
                thiscolor = (int)((1.0f - (sqrt ((linex*linex)+(pehy*pehy)) / (float)m_BrushRadius)) * 255.0f);
                int newValue = m_LevelInfo.SetValueAdditive (segment, segx+linex, segy+pehy, thiscolor);
                if (newValue != -1)
                {
                    pos.x = linex+x; pos.y = y+pehy;
                    dc->SetPixel (pos, RGB(newValue,newValue,newValue));
                }
            }

            pehx = _x; pehy = -_y;
            thisradius = m_BrushRadius - (m_BrushRadius-pehx);
            for (linex = -thisradius; linex < thisradius; linex++)
            {
                thiscolor = (int)((1.0f - (sqrt ((linex*linex)+(pehy*pehy)) / (float)m_BrushRadius)) * 255.0f);
                int newValue = m_LevelInfo.SetValueAdditive (segment, segx+linex, segy+pehy, thiscolor);
                if (newValue != -1)
                {
                    pos.x = linex+x; pos.y = y+pehy;
                    dc->SetPixel (pos, RGB(newValue,newValue,newValue));
                }
            }
        }

        for (int linex = -m_BrushRadius; linex < m_BrushRadius; linex++)
        {
            int thiscolor = (int)((1.0f - (sqrt ((linex*linex)) / (float)m_BrushRadius)) * 255.0f);
            int newValue = m_LevelInfo.SetValueAdditive (segment, segx+linex, segy, thiscolor);
            if (newValue != -1)
            {
                pos.x = linex+x; pos.y = y;
                dc->SetPixel (pos, RGB(newValue,newValue,newValue));
            }
        }
    }*/
    #define SETHEIGHTVALUE(dc,tx,ty,c) { \
        int thisradius = m_BrushRadius - (m_BrushRadius-tx); \
        POINT pos; \
        for (int linex = -thisradius; linex < thisradius; linex++) \
        { \
            int thiscolor = (int)((1.0f - (sqrt ((linex*linex)+(ty*ty)) / (float)m_BrushRadius)) * 255.0f); \
            int newValue = m_LevelInfo.SetValueAdditive (segment, segx+linex, segy+ty, thiscolor); \
            if (newValue != -1) \
            { \
                pos.x = linex+x; pos.y = y+ty; \
                dc->SetPixel (pos, RGB(newValue,newValue,newValue)); \
            } \
        } \
    } \

    /*#define SETHEIGHTVALUE(dc,tx,ty,c) { \
        int thisradius = m_BrushRadius - (m_BrushRadius-tx); \
        POINT pos; \
        for (int linex = -thisradius; linex < thisradius; linex++) \
        { \
            float ratio = ( 1.0f - ( (float)sqrt ( (linex*linex)+(ty*ty) ) ) ); \
            int thisColor = ((int)((ratio*255.0f)  / (float)m_BrushRadius)); \
            int newValue = m_LevelInfo.SetValuePercentage (segment, segx+linex,segy+ty, ratio, thisColor); \
            if (newValue != -1) \
            { \
                pos.x = linex+x; pos.y = y+ty; \
                dc->SetPixel (pos, RGB(newValue,newValue,newValue)); \
            } \
        } \
    } \*/

    /*#define SETHEIGHTVALUE(dc,tx,ty,c) { \
        int thisradius = m_BrushRadius - (m_BrushRadius-tx); \
        POINT pos; \
        for (int linex = -thisradius; linex < thisradius; linex++) \
        { \
            pos.x = linex+x; pos.y = y+ty; \
            dc->SetPixel (pos, RGB(c,c,c)); \
        } \
    } \*/

    

    /*int _y = m_BrushRadius;
    int d = 3 - 2*m_BrushRadius;
    int _x = 0;
    bool doneZero = false;
    
    CDC *dc = m_LevelView.GetDC ();

    bool *bDoneLUT = new bool[m_BrushRadius*2];
    for (int peh = 0; peh < m_BrushRadius*2; peh++) bDoneLUT[peh] = false;

    while (_y > _x)
    {
        if (bDoneLUT[_y] == false)
        {
            SETHEIGHTVALUE(dc,_x,_y, 255);
            SETHEIGHTVALUE(dc,_x,-_y, 255);
            SETHEIGHTVALUE(dc,_y,_x, 255);
            SETHEIGHTVALUE(dc,_y,-_x, 255);
            bDoneLUT[_y] = true;
        }

        if(d<0) 
        {
            d = d +(4*_x) + 6;
        }
        else 
        if (d > 0)
        {
            d = d +4*(_x - _y) + 10;
            _y = _y - 1;
        }

        _x = _x + 1;
    }

    delete []bDoneLUT;*/


    //
    // If there is overlap then do something something
    

    return true;
}

bool    CEditorDlg::PlaceObject (int x, int y)
{
    int segment = 0;
    int segx = x, segy;  

    //
    // Work out which segment we are on
    if (y < LEVEL_SEGMENT_SIZE) 
    {
        segment = 2 + m_ScrollPosition;
        segy = y;
    }
    else
    if (y < LEVEL_SEGMENT_SIZE*2) 
    {
        segment = 1 + m_ScrollPosition;
        segy = y-LEVEL_SEGMENT_SIZE;
    }
    else
    if (y < LEVEL_SEGMENT_SIZE*3) 
    {
        segment = 0 + m_ScrollPosition;
        segy = y-LEVEL_SEGMENT_SIZE*2;
    }

    int sel = m_ObjectList.GetCurSel ();
    if (sel != LB_ERR)
    {
        CString str;
        m_ObjectList.GetText (sel, str);

        m_LevelInfo.AddObject (str.GetBuffer (50), segment, segx, segy);
    }

    CDC *dc = m_LevelView.GetDC ();

    RECT rect;
    rect.left = x-4;
    rect.right = x+4;
    rect.top = y-4;
    rect.bottom = y+4;

    dc->SelectObject (m_ObjBrush);
    dc->Rectangle (&rect);

    return true;
}

bool  CEditorDlg::RemoveObject (int x, int y)
{
    int segment = 0;
    int segx = x, segy;  

    //
    // Work out which segment we are on
    if (y < LEVEL_SEGMENT_SIZE) 
    {
        segment = 2 + m_ScrollPosition;
        segy = y;
    }
    else
    if (y < LEVEL_SEGMENT_SIZE*2) 
    {
        segment = 1 + m_ScrollPosition;
        segy = y-LEVEL_SEGMENT_SIZE;
    }
    else
    if (y < LEVEL_SEGMENT_SIZE*3) 
    {
        segment = 0 + m_ScrollPosition;
        segy = y-LEVEL_SEGMENT_SIZE*2;
    }

    FileLevelObject *obj = (FileLevelObject*)m_LevelInfo.segments[segment].ObjectList.Rewind ();
    while (obj)
    {
        // draw from the bottom up
        int p = segment;

        if (segment == 0) p = 2;
        if (segment == 2) p = 0;
        
        if (segx > obj->x - 4 && segx < obj->x + 4 &&
            segy > obj->y-4 && segy < obj->y+4)
        {
            m_LevelInfo.segments[segment].ObjectList.Remove (m_LevelInfo.segments[segment].ObjectList.Find(obj));
            delete obj;
            PaintLevel ();
            return true;
        }
                
        obj = (FileLevelObject*)m_LevelInfo.segments[segment].ObjectList.Next ();
    }
    

    return true;
}

void CEditorDlg::OnEditmode() { m_Mode = MODE_EDIT; }
void CEditorDlg::OnPaintmode() { m_Mode = MODE_PAINT; }
void CEditorDlg::OnPlacemode() { m_Mode = MODE_PLACE; }

void CEditorDlg::OnLButtonDown(UINT nFlags, CPoint point) 
{
    if (point.x >LEVELVIEW_X && point.x < LEVELVIEW_X + LEVEL_SEGMENT_SIZE  &&
        point.y > LEVELVIEW_Y && point.y < LEVELVIEW_Y + LEVEL_SEGMENT_SIZE*3)
    {
        /*if (m_Mode == MODE_PAINT)
            MouseClickedOnMap (point.x - LEVELVIEW_X, point.y - LEVELVIEW_Y);*/

        if (m_Mode == MODE_PLACE)
            PlaceObject (point.x - LEVELVIEW_X, point.y - LEVELVIEW_Y);

        if (m_Mode == MODE_EDIT)
            RemoveObject (point.x - LEVELVIEW_X, point.y - LEVELVIEW_Y);
            
    }
    
	
	CDialog::OnLButtonDown(nFlags, point);
}



void CEditorDlg::OnImportterrain() 
{
    char path[200];
    sprintf (path, "%s\\*.RAW", m_AppPath);
    CFileDialog fileDialog  (true, "RAW", path, OFN_HIDEREADONLY | OFN_FILEMUSTEXIST, "RAW files (*.RAW)\0*.RAW\0", this);	

    int ret = fileDialog.DoModal ();
    if (ret != IDCANCEL)
    {
        CInputDlg dlg;

        int peh = dlg.DoModal ();
        if (peh == IDCANCEL)
            return;

        int numSegments = atoi (dlg.m_Value.GetBuffer (5));
        if (numSegments < 3 || numSegments > 100)
        {
            MessageBox ("invalid segment amount. must be between 3 and 100.");
            return;
        }

        // Load in data
        if (numSegments != m_LevelInfo.numSegments)
            m_LevelInfo.Initialize (numSegments);
        
        CString strFilename = fileDialog.GetPathName ();

        FILE *file = fopen (strFilename.GetBuffer (50), "rb");
        if (!file)
        {
            MessageBox ("couldn't open file");
            return;
        }

        for (int seg = 0; seg < numSegments; seg++)
        {
            for (int y = 0; y < LEVEL_SEGMENT_SIZE; y++)
            {
                for (int x = 0; x < LEVEL_SEGMENT_SIZE; x++)
                {
                    BYTE value;
                    fread (&value, 1, 1, file);

                    m_LevelInfo.segments[numSegments-1-seg].segmentData[x][y] = value;
                }
            }
        }

        int bytesread = ftell (file);

        fclose (file);
    }

    PaintLevel ();
}

void CEditorDlg::OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
    if (nSBCode == SB_LINEUP)
    {
        m_ScrollPosition++;
        if (m_ScrollPosition > m_LevelInfo.numSegments - 3)
        {
            m_ScrollPosition = m_LevelInfo.numSegments - 3;
            return;
        }

        PaintLevel ();
    }

    if (nSBCode == SB_LINEDOWN)
    {
        m_ScrollPosition--;
        if (m_ScrollPosition < 0)
        {
            m_ScrollPosition = 0;
            return;
        }            

        PaintLevel ();
    }
        
	CDialog::OnVScroll(nSBCode, nPos, pScrollBar);
}


void CEditorDlg::OnMouseMove(UINT nFlags, CPoint point) 
{
    if (point.x >LEVELVIEW_X && point.x < LEVELVIEW_X + LEVEL_SEGMENT_SIZE  &&
        point.y > LEVELVIEW_Y && point.y < LEVELVIEW_Y + LEVEL_SEGMENT_SIZE*3)
    {
        point.x = point.x - LEVELVIEW_X;
        point.y = point.y - LEVELVIEW_Y;
            
        int segment = 0;
        int segx = point.x, segy;  

        //
        // Work out which segment we are on
        if (point.y < LEVEL_SEGMENT_SIZE) 
        {
            segment = 2 + m_ScrollPosition;
            segy = point.y;
        }
        else
        if (point.y < LEVEL_SEGMENT_SIZE*2) 
        {
            segment = 1 + m_ScrollPosition;
            segy = point.y-LEVEL_SEGMENT_SIZE;
        }
        else
        if (point.y < LEVEL_SEGMENT_SIZE*3) 
        {
            segment = 0 + m_ScrollPosition;
            segy = point.y-LEVEL_SEGMENT_SIZE*2;
        }

        FileLevelObject *obj = (FileLevelObject*)m_LevelInfo.segments[segment].ObjectList.Rewind ();
        while (obj)
        {
            // draw from the bottom up
            int p = segment;

            if (segment == 0) p = 2;
            if (segment == 2) p = 0;
        
            if (segx > obj->x - 4 && segx < obj->x + 4 &&
                segy > obj->y-4 && segy < obj->y+4)
            {
                m_InfoLine = obj->name;
                UpdateData (FALSE);
                
                return;
            }
                
            obj = (FileLevelObject*)m_LevelInfo.segments[segment].ObjectList.Next ();
        }
    }

    m_InfoLine = "";
    UpdateData (FALSE);
	
	CDialog::OnMouseMove(nFlags, point);
}
