// EditorDlg.h : header file
//

#if !defined(AFX_EDITORDLG_H__87E5F3DB_0C2C_4703_B9F5_21FD26950675__INCLUDED_)
#define AFX_EDITORDLG_H__87E5F3DB_0C2C_4703_B9F5_21FD26950675__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "..\Source\LevelFormat.h"

#define MODE_PAINT 0
#define MODE_PLACE 1
#define MODE_EDIT  2

/////////////////////////////////////////////////////////////////////////////
// CEditorDlg dialog

class CEditorDlg : public CDialog
{
// Construction
public:
	CEditorDlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	//{{AFX_DATA(CEditorDlg)
	enum { IDD = IDD_EDITOR_DIALOG };
	CListBox	m_ObjectList;
	CStatic	m_LevelView;
	CString	m_strRadius;
	CString	m_strWeight;
	CString	m_InfoLine;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CEditorDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

    LevelInfo       m_LevelInfo;
    int             m_ScrollPosition;
    int             m_Mode;

    int             m_BrushRadius;
    int             m_BrushWeight;

    bool            PaintLevel ();
    bool            MouseClickedOnMap (int x, int y);
    bool            PlaceObject (int x, int y);
    bool            RemoveObject (int x, int y);
    
    CString         m_Filename;

    char            m_AppPath[200];

    HBRUSH          m_ObjBrush;
    
// Implementation
protected:
	HICON m_hIcon;

	// Generated message map functions
	//{{AFX_MSG(CEditorDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnNew();
	afx_msg void OnSave();
	afx_msg void OnSaveas();
	afx_msg void OnDeltaposSpinradius(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnEditmode();
	afx_msg void OnPaintmode();
	afx_msg void OnPlacemode();
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnLoad();
	afx_msg void OnImportterrain();
	afx_msg void OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_EDITORDLG_H__87E5F3DB_0C2C_4703_B9F5_21FD26950675__INCLUDED_)
